package org.apache.bcel.generic;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.io.DataOutputStream;
import java.io.IOException;
import org.apache.bcel.generic.ClassGenException;
import org.apache.bcel.generic.ConstantPoolGen;
import org.apache.bcel.generic.IndexedInstruction;
import org.apache.bcel.generic.Instruction;
import org.apache.bcel.generic.ReturnaddressType;
import org.apache.bcel.generic.Type;
import org.apache.bcel.generic.TypedInstruction;
import org.apache.bcel.generic.Visitor;
import org.apache.bcel.util.ByteSequence;

public class RET extends Instruction implements IndexedInstruction, TypedInstruction {
  private boolean wide;
  
  private int index;
  
  RET() {}
  
  public RET(int index) {
    super((short)169, (short)2);
    setIndex(index);
  }
  
  public void accept(Visitor v) {
    v.visitRET(this);
  }
  
  public void dump(DataOutputStream out) throws IOException {
    if (this.wide)
      out.writeByte(196); 
    out.writeByte(getOpcode());
    if (this.wide) {
      out.writeShort(this.index);
    } else {
      out.writeByte(this.index);
    } 
  }
  
  public final int getIndex() {
    return this.index;
  }
  
  public Type getType(ConstantPoolGen cp) {
    return ReturnaddressType.NO_TARGET;
  }
  
  protected void initFromFile(ByteSequence bytes, boolean wide) throws IOException {
    this.wide = wide;
    if (wide) {
      this.index = bytes.readUnsignedShort();
      setLength(4);
    } else {
      this.index = bytes.readUnsignedByte();
      setLength(2);
    } 
  }
  
  public final void setIndex(int n) {
    if (n < 0)
      throw new ClassGenException("Negative index value: " + n); 
    this.index = n;
    setWide();
  }
  
  private void setWide() {
    this.wide = (this.index > 255);
    if (this.wide) {
      setLength(4);
    } else {
      setLength(2);
    } 
  }
  
  public String toString(boolean verbose) {
    return super.toString(verbose) + " " + this.index;
  }
}
